#ifndef __B_PERCOLOOPER_H
#define __B_PERCOLOOPER_H

#include <Looper.h>

class BMessageRunner;

class BPercoLooper : public BLooper
{
  public:
    BPercoLooper(BMessage *msg_generate);
    ~BPercoLooper();
    
    virtual void MessageReceived(BMessage *msg_received);
    
  private:
    status_t Render();
    void WaitDirective();
    void PingReplied(BMessage *msg_pingreply);
    void PingReceived(BMessage *msg_ping);
    void TerminateRequest(BMessage *msg_terminate);
    void ResizeNotify(BMessage *msg_resize);
    void TypechangeNotify(BMessage *msg_typechange);
    void ImagechangeNotify(BMessage *msg_imagechange);
  
    BMessage *msg_Settings;
  
    BMessageRunner *msr_Pinger;
    BMessenger *lnk_This;
    BMessenger *lnk_Client;
    BMessenger *lnk_Manager;
    
    int32 pingcount;
    int32 flg_Settings;
    int32 flg_Status;
    image_id img_Code;
};

//Settings flags
#define B_PERCO_DEFAULT			0x00000000
#define B_PERCO_VERBOSE			0x00000007
#define B_PERCO_INFORMATION		0x00000004
#define B_PERCO_ERRORONLY		0x00000003
#define B_PERCO_NOTICES			0x00000002
#define B_PERCO_REPORT			0x00000001
#define B_PERCO_NEEDS_REFRESH	0x00010000

#endif