//PercoManager.cpp -- this is the percolator's image manager.

#include <stdlib.h>
#include <String.h>
#include <Message.h>
#include <File.h>
#include <TypeConstants.h>
#include "Verbosity.h"
#include "PercoManager.h"
#include "PercoInternalMessaging.h"

BPercoManager::BPercoManager()
  :BLooper("Addon Image Manager")
{
  LoadSettings();
  GenerateUserList();
};

BPercoManager::~BPercoManager()
{
  if (tbl_ImageNums)
    delete tbl_ImageNums;
  if (tbl_ImageLocs)
    delete tbl_ImageLocs;
  if (tbl_ImageUser)
    delete tbl_ImageUser;
};

void BPercoManager::MessageReceived(BMessage *msg_received)
{
  switch (msg_received->what)
  {
    case B_PERCOLATOR_IMAGE_REQUEST:
      ReturnImageId(msg_received);
    break;
    default:
      BLooper::MessageReceived(msg_received);
  };
};

void BPercoManager::ReturnImageId(BMessage *msg_request)
{
  BMessage *msg_IdResponse = new BMessage(B_PERCOLATOR_IMAGE_REPLY);
    BString		str_Mimename;
    image_id	idn_Response;
    
    msg_request->FindString("Be:PERC:mimetype",&str_Mimename);
    tbl_ImageNums->FindInt32(str_Mimename.String(),idn_Response);
   
    msg_IdResponse->AddInt32("Be:PERC:imageid",idn_Response);
    
    cout << "prior to sending reply..." << endl;
    
    msg_request->SendReply(msg_IdResponse);
  delete msg_IdResponse;
};

status_t BPercoManager::LoadSettings()
{
  BFile *file_Settings = new BFile("/boot/home/config/settings/percolator/PercolatorPrefs",B_READ_ONLY);

  VerboseReply(file_Settings->InitCheck(), "Loading prefs file", true);
  
  BMessage *msg_Settings = new BMessage();
  tbl_ImageLocs = new BMessage();
  VerboseReply(msg_Settings->Unflatten(file_Settings), "Unflattening file", true);
  VerboseReply(msg_Settings->FindMessage("Be:PERC:mimetype",tbl_ImageLocs), "Extracting image paths" , true );
    
  delete file_Settings;
    
  return B_OK;
};

status_t BPercoManager::ReloadSettings()
{
  return B_OK;
};

status_t BPercoManager::Select(BMessage *msg_Select)
{
  return B_OK;
};