#include <iostream.h>
#include <stdlib.h>
#include <String.h>
#include <string.h>
#include <stdio.h>
#include "HtmlFlags.h"

void outvalue(BString &value, bool nchcap = false)
{ 
  if (!nchcap)
    value.ToUpper();
  cout << "|value:  |" << value.String() << "|" << endl;
  value = "";
};

void outattrib(BString &attrib, bool nchcap = false)
{ 
  if (!nchcap)
    attrib.ToUpper();
  cout << "|attrib: |" << attrib.String() << "|" << endl;
  attrib = "";
};

void outtext(BString &text)
{ 
  cout << "|text:   |" << text.String() << "|" << endl;
  text = "";
};

void outtag(BString &tag, bool nchcap = false)
{
  if (!nchcap)
    tag.ToLower();
  cout << "|tag:    |" << tag.String() << "|" << endl;
  tag = "";
};

void outetag(BString &etag, bool nchcap = false)
{
  if (!nchcap)
    etag.ToLower();
  cout << "|etag:   |" << etag.String() << "|" << endl;
  etag = "";
};

void outcomment(BString &comment)
{
  cout << "|comment:|" << comment.String() << "|" << endl;
};

void error(char *errmsg)
{ cout << "|ERROR!  |" << errmsg << endl;};

char outspchar(BString &type)
{
  if (type == "gt")
    return '>';
  else if (type == "lt")
    return '<';
  else if (type == "quot")
    return '"';
  else if (type == "amp")
    return '&';
  else if (type == "nbsp")
    return ' ';
  else if (type == "brvbar")
    return '|';
  else
  {
    error("bad special character code!");
    return 'X';
  };
};

void starttag(BString &Buffer, int32 &htmlflags)
{
  if (htmlflags & B_IN_TEXT)
  {
    if (htmlflags & B_HAS_CONTENT)
    {
      outtext(Buffer);
      htmlflags ^= B_HAS_CONTENT;
    }
    htmlflags &= (!B_IN_TEXT);
    htmlflags |= B_IN_TAG;
  }
  else
    error("cannot start tag entry");
};

void endtagunit(BString &Buffer, int32 &htmlflags)
{
  if (htmlflags & B_IN_ATTRIBUTE)
    outattrib(Buffer, htmlflags & B_IN_TAG_STRING);
  else if (htmlflags & B_IN_ATTRIBUTE_VALUE)
    outvalue(Buffer, htmlflags & B_IN_TAG_STRING);
  else outtag(Buffer, htmlflags & B_IN_TAG_STRING);
  htmlflags &= ((B_HAS_CONTENT | B_IN_ATTRIBUTE_VALUE | B_IN_TAG_STRING) ^ B_TOTAL_MASK);
  htmlflags |= (B_IN_ATTRIBUTE);
};

void endtag(BString &Buffer, int32 &htmlflags)
{
  if (htmlflags & B_IN_TAG)
  {
    if (htmlflags & B_TAG_IS_END)
      outetag(Buffer);
    else
      if (htmlflags & B_HAS_CONTENT)
        endtagunit(Buffer, htmlflags);
    htmlflags &= ((B_HAS_CONTENT | B_IN_TAG | B_TAG_IS_END) ^ B_TOTAL_MASK);
    htmlflags |= B_IN_TEXT;
  }
  else
    error("not in tag to end tag");
};

void whitespace(BString &Buffer, int32 &htmlflags)
{
  if (htmlflags & B_IS_WHITESPACED)
    htmlflags |= B_IS_WHITESPACED;
  else
  {
    htmlflags |= B_IS_WHITESPACED;
    if (htmlflags & B_IN_TEXT)
    {
      Buffer << " ";
      htmlflags |= B_HAS_CONTENT;
    }
    else if (htmlflags & B_IN_TAG)
    {
      if (htmlflags & B_TAG_IS_END)
      {
        error("end tag with whitespace!");
        outetag(Buffer);
      }
      else
        if (htmlflags & B_HAS_CONTENT)
          endtagunit(Buffer, htmlflags);
    }
    else error("strange flag situation");
  };
};

void etagmarker(BString &Buffer, int32 &htmlflags)
{
  if (htmlflags & B_IN_TAG)
    htmlflags |= B_TAG_IS_END;
  else
    Buffer << '/';
};

void atvalmarker(BString &Buffer, int32 &htmlflags)
{
  if (htmlflags & B_IN_TAG)
    if (htmlflags & B_IN_ATTRIBUTE)
    {
      htmlflags &= (B_IN_ATTRIBUTE ^ B_TOTAL_MASK);
      htmlflags |= B_IN_ATTRIBUTE_VALUE;
    }
    else
      error("strange = placement");
  else
    Buffer << '=';
};

void startspchar(BString &Buffer, int32 &htmlflags)
{
  if (htmlflags & B_IN_TEXT)
    htmlflags |= B_IN_SPECIAL_CHARACTER;
  else
    Buffer << '&';
};

void endspchar(BString &Buffer, BString &SpBuffer, int32 &htmlflags)
{
  if (htmlflags & B_IN_TEXT)
    if (htmlflags & B_IN_SPECIAL_CHARACTER)
    {
      Buffer << outspchar(SpBuffer);
      SpBuffer = "";
      htmlflags &= (B_IN_SPECIAL_CHARACTER ^ B_TOTAL_MASK);
    }
    else
      Buffer << ';';
};

void startcommentcount(BString &Buffer, int32 &htmlflags)
{
  if (htmlflags & B_IN_TAG)
  {
    htmlflags &= (B_COMMENTING_MASK ^ B_TOTAL_MASK);
    htmlflags |= B_COMMENT_FIRST;
  };
};

void parsecommentcount(BString &Buffer, int32 &htmlflags)
{
  if (htmlflags & B_IN_TAG)
  {
    if (htmlflags & B_COMMENT_SECOND)
      htmlflags |= (B_IN_COMMENT | B_IN_TAG_STRING);
    if (htmlflags & B_COMMENT_FIRST)
      htmlflags |= B_COMMENT_SECOND;
  };
};

void endcomment(BString &Buffer, int32 &htmlflags)
{
  if (htmlflags & B_IN_COMMENT)
    if (htmlflags & B_COMMENT_SECOND)
    {
      outcomment(Buffer);
      htmlflags &= ((B_HAS_CONTENT | B_TAG_IS_END |
              B_IN_TAG | B_IN_TAG_STRING | B_COMMENTING_MASK) ^ B_TOTAL_MASK);
      htmlflags |= B_IN_TEXT;
      Buffer = "";
    };
};

void parsecommenthyphens(int32 &htmlflags)
{
  if (htmlflags & B_COMMENT_FIRST)
    htmlflags |= B_COMMENT_SECOND;
  else
    htmlflags |= B_COMMENT_FIRST;
};

void munge(char *text)
{
  int32 htmlflags = B_IN_TEXT;
  char *examine; BString Buffer("");  BString SpBuffer("");
  int32 index = 0; int32 total = strlen(text);
  cout << "munging: " << text << endl;
  examine = text;
  
  while (index < total)
  {
    if (htmlflags & B_IN_TAG_STRING)
    {
      if (*examine == '"')
      {
        if (htmlflags & B_IN_COMMENT == 0)
          endtagunit(Buffer, htmlflags);
      }
      else if (*examine == '>')
        endcomment(Buffer, htmlflags);
      else if (*examine == '-')
        parsecommenthyphens(htmlflags);
      else
      {
        htmlflags &= (B_LESSER_COMMENT_MASK ^ B_TOTAL_MASK);
        Buffer << *examine;
      };
    }
    else switch (*examine)
    {
      case '<':
        starttag(Buffer, htmlflags);
      break;
      case '>':
        endtag(Buffer, htmlflags);
      break;
      case ' ':
        if (htmlflags & B_WHITESPACE_COUNTS)
        {
          if (htmlflags & B_IN_TEXT)
            Buffer << *examine;
        }
        else
          whitespace(Buffer, htmlflags);
      break;
      case '&':
        startspchar(Buffer, htmlflags);
      break;
      case ';':
        endspchar(Buffer, SpBuffer, htmlflags);
      break;
      case '/':
        etagmarker(Buffer, htmlflags);
      break;
      case '=':
        atvalmarker(Buffer, htmlflags);
      break;
      case '!':
        startcommentcount(Buffer, htmlflags);
      break;
      case '-':
        parsecommentcount(Buffer, htmlflags);
      break;
      case '"':
        if (htmlflags & B_IN_TAG)
          htmlflags |= B_IN_TAG_STRING;
      break;
      default:
        if (htmlflags & B_IN_SPECIAL_CHARACTER)
          SpBuffer << *examine;
        else
          Buffer << *examine;
        htmlflags |= B_HAS_CONTENT;
        htmlflags &= ((B_IS_WHITESPACED) ^ B_TOTAL_MASK);
    };
    index++;
    examine++;
  };
  
  if ((htmlflags & B_HAS_CONTENT))
    if ((htmlflags & B_IN_TEXT))
      outtext(Buffer);
    else
      error("unexpected end of text");
  
  cout << endl;
};

int main()
{
  char *string = (char *) malloc(sizeof(char) * 200);
  gets(string);
  munge(string);
  
  return 0;
};