//PercoLinker.h -- this file describes the percolinker percolator helper class.

#ifndef __B_PERCOLINKER_H
#define __B_PERCOLINKER_H

  #if __BUILDING_PERCOLINKER_H
    #define __PERCOLINKER_TYPED __declspec(dllimport)
  #else
    #define __PERCOLINKER_TYPED __declspec(dllexport)
  #endif

#include <Looper.h>

class BMessage;
class BMessenger;
class BPercolatorConduit;

class __PERCOLINKER_TYPED BPercoLinker:public BLooper
{
  public:
    BPercoLinker(const char *name, BMessenger *inf_lnk_percolator = NULL);
    ~BPercoLinker();
       
    virtual void	MessageReceived(BMessage *msg_received);
    
    void			AssociateConduit(BPercolatorConduit *lnk_conduit);
  
  private:
    //protected functions
    void			FrameResized(BMessage *msg_resize);
    void			PingReceived(BMessage *msg_ping);
    void			Redirect(BMessage *msg_redirect);
    
    BRect				rct_StartFrame;
    BMessenger			*lnk_Percolator;
    BPercolatorConduit	*lnk_Conduit;
};

#endif